//Nesscessary Include Files
#include <math.h>
#include <stdio.h>
#include "parameters.h"


double inv_g_func (double x);
double g_func (double x);

double func_f( double x);
short infinity_test(short x);


void LDPC_Decoder(volatile double* BPSK_AWGN_Codeword)
{

	volatile int i;
	volatile int j;
	volatile int k;
	volatile int l;
	volatile int m;
	volatile int temp2;
	volatile int ind;

	volatile int Row_In_Column[COLUMN_WEIGHT][COLUMNS];
	volatile int Column_In_Row[ROW_WEIGHT][ROWS];
	
	short LRft[COLUMNS]; 
	short LRrtl[COLUMNS][ROWS]; 
	short LRqtl[COLUMNS][ROWS]; 
	short LRpt[COLUMNS];

	short Bins[65];

	double temp3;
	double temp_sign;
	double sign;
	double magnitude;

	double No;
	double snr;
	
	
    FILE* row_in_col;
    FILE* col_in_row;
	FILE* out;
	FILE* index;


	out = fopen("debug.txt","w");
	index = fopen("index.txt","w");
	
    row_in_col = fopen(row_in_col_fn, "r");
    col_in_row = fopen(col_in_row_fn, "r");


	
	  for(i = 0; i < COLUMN_WEIGHT; i++)
	  {
	     fprintf(index,"\n");
		  for(j=0; j< COLUMNS; j++)
         {
            fscanf(row_in_col,"%d",&temp2);
			Row_In_Column[i][j] = temp2-1;
			fprintf(index,"i ",Row_In_Column[i][j]);
	     }
	  }


	  
	  
	
	  
	
    for(i = 0; i < ROW_WEIGHT; i++)
	{
    
		for(j=0; j< ROWS; j++)
         {
            fscanf(col_in_row,"%d",&temp2);
			Column_In_Row[i][j] =  temp2-1; //swap j and i
		
		 }
	}



	fprintf(index,"\n");


    for(i = 0; i < ROWS; i++)
	{
        fprintf(index,"\n"); 
		for(j=0; j< ROW_WEIGHT; j++)
         {
            
			fprintf(index,"%i ",Column_In_Row[i][j]); 
	
		 }
	}


	
	
	fclose(row_in_col);
	fclose(col_in_row);
	fclose(index);

			 
		 
		 
	snr = pow(10.0,SNRdB/10.0);

	No = 2.0/snr; 





	fprintf(out,"\nsnr %lf ",snr);
	fprintf(out,"\nNo %lf ",No);
	
	fprintf(out,"\n\nLRft: \n");
	//Initialize
	for(i=0; i < COLUMNS; i++)
	{
		LRft[i] = (short)  (4*ES/No)*BPSK_AWGN_Codeword[i];
		
		LRft[i] = infinity_test(LRft[i] );
		
		fprintf(out,"%i ",LRft[i]);

		LRpt[i] = 0;
	}


 

	 for(i = 0; i < COLUMNS; i++)
		 for( j = 0; j < ROWS; j++)
		 {
			 LRrtl[i][j] = 0;
			 LRqtl[i][j] = 0;
		 }
	 


	


	 
	 //Bit to Check Node Messages --> LRqtl
	 for(i = 0; i < ITERATIONS; i++)
	 {
		for(k = 0; k < COLUMNS; k++)
		{
			for(l = 0; l < COLUMN_WEIGHT; l++)  
			{	
				temp3 = LRft[k];
				for (m = 0; m < COLUMN_WEIGHT; m++) 
				{
					if (m != l)
					{
						temp3 += LRrtl[k][Row_In_Column[m][k]];
						//LRqtl[ k][Row_In_Column[l][k] ] =  infinity_test(LRqtl[ k][Row_In_Column[l][k] ]);
					}
				}

				LRqtl[ k][Row_In_Column[l][k] ] =  (short) temp3;

			}
		}


		fprintf(out,"\n\n\nLRqtl iteration %i\n",i);
		for(k=0; k <COLUMNS; k++)
		{fprintf(out,"\n");
			for(m=0;m<ROWS;m++)
				fprintf(out,"%i ",LRqtl[k][m]);
		}

		
		//Check to Bit Node Messages --> LRrtl
		for(k = 0; k < ROWS; k++)
		{
			for(l = 0; l < ROW_WEIGHT; l++)
			{
				temp3 = 0.0;
				sign=1;
				for( m =0; m < ROW_WEIGHT; m++)
				{
					if( m != l)
					{
						temp3 = temp3 + func_f( fabs( LRqtl[Column_In_Row[m][k]][k] ) );

						if(LRqtl[Column_In_Row[m][k]][k] > 0.0)
							temp_sign = 1;

						else 
							temp_sign = -1;

						
						sign=sign*temp_sign;
					}
					
					
				}

				magnitude =  func_f(temp3);

				LRrtl[ Column_In_Row[l][k]] [k] =   (short) sign*magnitude;
				
			}
		}


		fprintf(out,"\n\n\nLRrtl iteration %i\n",i);
		for(k=0; k <COLUMNS; k++)
			{fprintf(out,"\n");
			for(m=0;m<ROWS;m++)
				fprintf(out,"%i ",LRrtl[k][m]);
		}




		//Last iteration get LR (pi)
		for(m =0; m < COLUMNS; m++)
		{
			LRpt[m] = LRft[m];
			LRpt[m] =  infinity_test(LRpt[m]);
			for(k = 0; k < COLUMN_WEIGHT; k++)
			{
				LRpt[m] += LRrtl[m][Row_In_Column[k][m] ];
				LRpt[m] =  infinity_test(LRpt[m]);
			
			}
		}


		fprintf(out,"\n\n\nLRpt iteration %i\n",i);
		{fprintf(out,"\n");
			for(m=0;m<COLUMNS;m++)
				fprintf(out,"%i ",LRpt[m]);
		}

		for (ind=0;ind<65;ind++)
			Bins[ind] = 0;
		
		
		for (ind=0;ind<COLUMNS;ind++)
		{
			Bins[LRpt[ind]+32] ++;
		}

		
		fprintf(out,"\n\nBINS\n");
		for (ind=0;ind<65;ind++)
			fprintf(out,"%d ",Bins[ind]);

		fprintf(out,"\n\n");

	 }
	
	 //Make Decision
	for(i = 0; i < COLUMNS; i++)
	{
		if( LRpt[i] >= 0)
			BPSK_AWGN_Codeword[i] = 1;

		else
			BPSK_AWGN_Codeword[i] = 0;
	}


	fclose(out);


	
}



double g_func( double x)
{

	return ( tanh(-x/2) );

}

double inv_g_func (double x)
{


	if(x == -1)
		return ( INFINITY );

	else
	{
		if ( x == 1)
			return ( -INFINITY);

		else
			return (  log((1-x)/(1+x)) );

	}

}


double func_f( double x)
{

	if( x >= BIG_INFINITY)
		return (1/BIG_INFINITY);

	else if ( x <= (1/BIG_INFINITY) )
		return( BIG_INFINITY);

	else
		return  (  log((exp(x)+1)/(exp(x)-1)));
}


short infinity_test(short x)
{
	if( x >= INFINITY)
		return INFINITY;
	else if( x <= -INFINITY)
		return -INFINITY;
	else
		return x;
}



